// Put this file in path/to/plugin/amd/src
// You can call it anything you like

define(['jquery', 'core/str', 'core/ajax', 'block_gradelevel/jscolor'], function ($, str, ajax, jscolor) {
    let self = {
        init: function init() {
            $("input[type=number].uint").on('change', function (evt) {
                let $this = $(this);
                if ($this.val() < 0) {
                    $this.val(0);
                }

            });

            $("a[data-action=addlevel]").on('click', function (evt) {
                let $newtr = $("<tr data-rowid=''>"
                    + "<td><input data-name='points' type='number' class='uint'></td>"
                    + "<td><input type='text' data-name='color' class='jscolor' value='7F7F7F'></td></tr>");

                let $tbody = $("table#level_config tbody");

                // apply jscolor to new row
                $newtr.find("input.jscolor").each(function () {
                    let picker = new jscolor(this);
                });
                // and add 
                $tbody.append($newtr);


            });

            $("button[data-action=savechanges]").on('click', self.submit);

        },
        submit: function submit(evt) {
            let $table = $("table#level_config");

            let data = { skill_id: $table.attr('data-skill'), levels: [] };
            $table.find("tbody tr[data-rowid]").each(function () {
                let $this = $(this);
                let row = {
                    id: $this.attr('data-rowid'),
                    points: $this.find("input[data-name=points]").val(),
                    color: $this.find("input[data-name=color]").val(),
                }
                data.levels.push(row);
            });

            console.info("Attempting to submit", data);

            $.post("#", { action: "submitchanges", data: data }, function (result) {
                console.info('result: ', result);
                window.location.href = '#';
            });

        }, 

    };
    return self;
});